# ------------------------------------------------------------------------------
# Generated by 'build-pre/build.r': do not edit by hand.
# ------------------------------------------------------------------------------

#' @title Convenience stats for row and column matrix factors
#' 
#' @description These statistical transformations (stats) adapt
#'   conventional **ggplot2** stats to one or the other matrix factor
#'   of a tbl_ord, in lieu of [stat_rows()] or [stat_cols()]. They
#'   accept the same parameters as their corresponding conventional
#'   stats.
#' 
#' @name biplot-stats
#' @template return-layer
#' @family biplot layers
#' @include layer-utils.r
#' @import ggplot2
#' @importFrom gggda
#'   StatCenter
#'   StatStar
#'   StatChull
#'   StatPeel
#'   StatCone
#'   StatDepth
#'   StatDepthFilled
#'   StatScale
#'   StatSpantree
#'   StatBagplot
#'   StatRule
#'   stat_center
#'   stat_star
#'   stat_chull
#'   stat_peel
#'   stat_cone
#'   stat_depth
#'   stat_depth_filled
#'   stat_scale
#'   stat_spantree
#'   stat_bagplot
#'   stat_rule
#'   minpp
#'   maxpp
#'   minabspp
#' @inheritParams ggplot2::layer
#' @template param-stat
#' @template biplot-ord-aes
#' @inheritParams stat_rows
#' @template param-referent
#' @inheritParams ggplot2::stat_density_2d
#' @inheritParams ggplot2::stat_density_2d_filled
#' @inheritParams ggplot2::stat_ellipse
#' @inheritParams gggda::stat_center
#' @inheritParams gggda::stat_star
#' @inheritParams gggda::stat_chull
#' @inheritParams gggda::stat_peel
#' @inheritParams gggda::stat_cone
#' @inheritParams gggda::stat_depth
#' @inheritParams gggda::stat_depth_filled
#' @inheritParams gggda::stat_scale
#' @inheritParams gggda::stat_spantree
#' @inheritParams gggda::stat_bagplot
#' @inheritParams gggda::stat_rule
#' @inheritParams stat_projection
#' @example inst/examples/ex-stat-bagplot-ord-iris.r
#' @example inst/examples/ex-stat-center-ord-iris.r
#' @example inst/examples/ex-stat-chull-ord-haireye.r
#' @example inst/examples/ex-stat-cone-ord-spend.r
#' @example inst/examples/ex-stat-ellipse-ord-iris.r
#' @example inst/examples/ex-stat-peel-ord-judges.r
#' @example inst/examples/ex-stat-projection-ord-iris.r
#' @example inst/examples/ex-stat-rule-ord-glass.r
#' @example inst/examples/ex-stat-spantree-ord-eurodist.r
NULL

#' @export
gggda::stat_center
#' @export
gggda::stat_star
#' @export
gggda::stat_chull
#' @export
gggda::stat_peel
#' @export
gggda::stat_cone
#' @export
gggda::stat_depth
#' @export
gggda::stat_depth_filled
#' @export
gggda::stat_scale
#' @export
gggda::stat_spantree
#' @export
gggda::stat_bagplot
#' @export
gggda::stat_rule

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsDensity2d <- ggproto(
  "StatRowsDensity2d", StatDensity2d,
  
  setup_data = setup_rows_xy_data,
  
  compute_group = ord_formals(StatDensity2d, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_density_2d <- function(
  mapping = NULL,
  data = NULL,
  geom = "density_2d",
  position = "identity",
  ...,
  contour = TRUE,
  contour_var = "density",
  n = 100,
  h = NULL,
  adjust = c(1, 1),
  na.rm = FALSE,
  show.legend = NA,
  inherit.aes = TRUE
) {
    layer(data = data, mapping = mapping, stat = StatRowsDensity2d, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list2(na.rm = na.rm, 
            contour = contour, contour_var = contour_var, 
            n = n, h = h, adjust = adjust, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsDensity2d <- ggproto(
  "StatColsDensity2d", StatDensity2d,
  
  setup_data = setup_cols_xy_data,
  
  compute_group = ord_formals(StatDensity2d, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_density_2d <- function(
  mapping = NULL,
  data = NULL,
  geom = "density_2d",
  position = "identity",
  ...,
  contour = TRUE,
  contour_var = "density",
  n = 100,
  h = NULL,
  adjust = c(1, 1),
  na.rm = FALSE,
  show.legend = NA,
  inherit.aes = TRUE
) {
    layer(data = data, mapping = mapping, stat = StatColsDensity2d, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list2(na.rm = na.rm, 
            contour = contour, contour_var = contour_var, 
            n = n, h = h, adjust = adjust, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsDensity2dFilled <- ggproto(
  "StatRowsDensity2dFilled", StatDensity2dFilled,
  
  setup_data = setup_rows_xy_data,
  
  compute_group = ord_formals(StatDensity2dFilled, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_density_2d_filled <- function(
  mapping = NULL,
  data = NULL,
  geom = "density_2d_filled",
  position = "identity",
  ...,
  contour = TRUE,
  contour_var = "density",
  n = 100,
  h = NULL,
  adjust = c(1, 1),
  na.rm = FALSE,
  show.legend = NA,
  inherit.aes = TRUE
) {
    layer(data = data, mapping = mapping, stat = StatRowsDensity2dFilled, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list2(na.rm = na.rm, 
            contour = contour, contour_var = contour_var, 
            n = n, h = h, adjust = adjust, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsDensity2dFilled <- ggproto(
  "StatColsDensity2dFilled", StatDensity2dFilled,
  
  setup_data = setup_cols_xy_data,
  
  compute_group = ord_formals(StatDensity2dFilled, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_density_2d_filled <- function(
  mapping = NULL,
  data = NULL,
  geom = "density_2d_filled",
  position = "identity",
  ...,
  contour = TRUE,
  contour_var = "density",
  n = 100,
  h = NULL,
  adjust = c(1, 1),
  na.rm = FALSE,
  show.legend = NA,
  inherit.aes = TRUE
) {
    layer(data = data, mapping = mapping, stat = StatColsDensity2dFilled, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list2(na.rm = na.rm, 
            contour = contour, contour_var = contour_var, 
            n = n, h = h, adjust = adjust, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsEllipse <- ggproto(
  "StatRowsEllipse", StatEllipse,
  
  setup_data = setup_rows_xy_data,
  
  compute_group = ord_formals(StatEllipse, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_ellipse <- function(
  mapping = NULL,
  data = NULL,
  geom = "path",
  position = "identity",
  ...,
  type = "t",
  level = 0.95,
  segments = 51,
  na.rm = FALSE,
  show.legend = NA,
  inherit.aes = TRUE
) {
    layer(data = data, mapping = mapping, stat = StatRowsEllipse, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list2(type = type, 
            level = level, segments = segments, na.rm = na.rm, 
            ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsEllipse <- ggproto(
  "StatColsEllipse", StatEllipse,
  
  setup_data = setup_cols_xy_data,
  
  compute_group = ord_formals(StatEllipse, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_ellipse <- function(
  mapping = NULL,
  data = NULL,
  geom = "path",
  position = "identity",
  ...,
  type = "t",
  level = 0.95,
  segments = 51,
  na.rm = FALSE,
  show.legend = NA,
  inherit.aes = TRUE
) {
    layer(data = data, mapping = mapping, stat = StatColsEllipse, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list2(type = type, 
            level = level, segments = segments, na.rm = na.rm, 
            ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsCenter <- ggproto(
  "StatRowsCenter", StatCenter,
  
  setup_data = setup_rows_xy_data,
  
  compute_group = ord_formals(StatCenter, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_center <- function(
  mapping = NULL,
  data = NULL,
  geom = "point",
  position = "identity",
  show.legend = NA,
  inherit.aes = TRUE,
  ...,
  fun.data = NULL,
  fun = NULL,
  fun.center = NULL,
  fun.min = NULL,
  fun.max = NULL,
  fun.ord = NULL,
  fun.args = list()
) {
    layer(data = data, mapping = mapping, stat = StatRowsCenter, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(fun.data = fun.data, 
            fun = fun, fun.center = fun.center, fun.min = fun.min, 
            fun.max = fun.max, fun.ord = fun.ord, fun.args = fun.args, 
            na.rm = FALSE, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsCenter <- ggproto(
  "StatColsCenter", StatCenter,
  
  setup_data = setup_cols_xy_data,
  
  compute_group = ord_formals(StatCenter, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_center <- function(
  mapping = NULL,
  data = NULL,
  geom = "point",
  position = "identity",
  show.legend = NA,
  inherit.aes = TRUE,
  ...,
  fun.data = NULL,
  fun = NULL,
  fun.center = NULL,
  fun.min = NULL,
  fun.max = NULL,
  fun.ord = NULL,
  fun.args = list()
) {
    layer(data = data, mapping = mapping, stat = StatColsCenter, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(fun.data = fun.data, 
            fun = fun, fun.center = fun.center, fun.min = fun.min, 
            fun.max = fun.max, fun.ord = fun.ord, fun.args = fun.args, 
            na.rm = FALSE, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsStar <- ggproto(
  "StatRowsStar", StatStar,
  
  setup_data = setup_rows_xy_data,
  
  compute_group = ord_formals(StatStar, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_star <- function(
  mapping = NULL,
  data = NULL,
  geom = "segment",
  position = "identity",
  show.legend = NA,
  inherit.aes = TRUE,
  ...,
  fun.data = NULL,
  fun = NULL,
  fun.center = NULL,
  fun.ord = NULL,
  fun.args = list()
) {
    layer(data = data, mapping = mapping, stat = StatRowsStar, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(fun.data = fun.data, 
            fun = fun, fun.center = fun.center, fun.ord = fun.ord, 
            fun.args = fun.args, na.rm = FALSE, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsStar <- ggproto(
  "StatColsStar", StatStar,
  
  setup_data = setup_cols_xy_data,
  
  compute_group = ord_formals(StatStar, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_star <- function(
  mapping = NULL,
  data = NULL,
  geom = "segment",
  position = "identity",
  show.legend = NA,
  inherit.aes = TRUE,
  ...,
  fun.data = NULL,
  fun = NULL,
  fun.center = NULL,
  fun.ord = NULL,
  fun.args = list()
) {
    layer(data = data, mapping = mapping, stat = StatColsStar, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(fun.data = fun.data, 
            fun = fun, fun.center = fun.center, fun.ord = fun.ord, 
            fun.args = fun.args, na.rm = FALSE, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsChull <- ggproto(
  "StatRowsChull", StatChull,
  
  setup_data = setup_rows_data,
  
  compute_group = ord_formals(StatChull, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_chull <- function(
  mapping = NULL,
  data = NULL,
  geom = "polygon",
  position = "identity",
  show.legend = NA,
  inherit.aes = TRUE,
  ...
) {
    layer(data = data, mapping = mapping, stat = StatRowsChull, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(na.rm = FALSE, 
            ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsChull <- ggproto(
  "StatColsChull", StatChull,
  
  setup_data = setup_cols_data,
  
  compute_group = ord_formals(StatChull, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_chull <- function(
  mapping = NULL,
  data = NULL,
  geom = "polygon",
  position = "identity",
  show.legend = NA,
  inherit.aes = TRUE,
  ...
) {
    layer(data = data, mapping = mapping, stat = StatColsChull, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(na.rm = FALSE, 
            ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsPeel <- ggproto(
  "StatRowsPeel", StatPeel,
  
  setup_data = setup_rows_data,
  
  compute_group = ord_formals(StatPeel, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_peel <- function(
  mapping = NULL,
  data = NULL,
  geom = "polygon",
  position = "identity",
  num = NULL,
  by = 1L,
  breaks = c(0.5),
  cut = c("above", "below"),
  show.legend = NA,
  inherit.aes = TRUE,
  ...
) {
    layer(data = data, mapping = mapping, stat = StatRowsPeel, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(num = num, 
            by = by, breaks = breaks, cut = cut, na.rm = FALSE, 
            ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsPeel <- ggproto(
  "StatColsPeel", StatPeel,
  
  setup_data = setup_cols_data,
  
  compute_group = ord_formals(StatPeel, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_peel <- function(
  mapping = NULL,
  data = NULL,
  geom = "polygon",
  position = "identity",
  num = NULL,
  by = 1L,
  breaks = c(0.5),
  cut = c("above", "below"),
  show.legend = NA,
  inherit.aes = TRUE,
  ...
) {
    layer(data = data, mapping = mapping, stat = StatColsPeel, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(num = num, 
            by = by, breaks = breaks, cut = cut, na.rm = FALSE, 
            ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsCone <- ggproto(
  "StatRowsCone", StatCone,
  
  setup_data = setup_rows_data,
  
  compute_group = ord_formals(StatCone, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_cone <- function(
  mapping = NULL,
  data = NULL,
  geom = "path",
  position = "identity",
  origin = FALSE,
  show.legend = NA,
  inherit.aes = TRUE,
  ...
) {
    layer(data = data, mapping = mapping, stat = StatRowsCone, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(na.rm = FALSE, 
            origin = origin, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsCone <- ggproto(
  "StatColsCone", StatCone,
  
  setup_data = setup_cols_data,
  
  compute_group = ord_formals(StatCone, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_cone <- function(
  mapping = NULL,
  data = NULL,
  geom = "path",
  position = "identity",
  origin = FALSE,
  show.legend = NA,
  inherit.aes = TRUE,
  ...
) {
    layer(data = data, mapping = mapping, stat = StatColsCone, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(na.rm = FALSE, 
            origin = origin, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsDepth <- ggproto(
  "StatRowsDepth", StatDepth,
  
  setup_data = setup_rows_data,
  
  compute_group = ord_formals(StatDepth, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_depth <- function(
  mapping = NULL,
  data = NULL,
  geom = "contour",
  position = "identity",
  contour = TRUE,
  contour_var = "depth",
  notion = "zonoid",
  notion_params = list(),
  n = 100L,
  show.legend = NA,
  inherit.aes = TRUE,
  ...
) {
    layer(data = data, mapping = mapping, stat = StatRowsDepth, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(contour = contour, 
            contour_var = contour_var, notion = notion, 
            notion_params = notion_params, n = n, na.rm = FALSE, 
            ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsDepth <- ggproto(
  "StatColsDepth", StatDepth,
  
  setup_data = setup_cols_data,
  
  compute_group = ord_formals(StatDepth, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_depth <- function(
  mapping = NULL,
  data = NULL,
  geom = "contour",
  position = "identity",
  contour = TRUE,
  contour_var = "depth",
  notion = "zonoid",
  notion_params = list(),
  n = 100L,
  show.legend = NA,
  inherit.aes = TRUE,
  ...
) {
    layer(data = data, mapping = mapping, stat = StatColsDepth, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(contour = contour, 
            contour_var = contour_var, notion = notion, 
            notion_params = notion_params, n = n, na.rm = FALSE, 
            ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsDepthFilled <- ggproto(
  "StatRowsDepthFilled", StatDepthFilled,
  
  setup_data = setup_rows_data,
  
  compute_group = ord_formals(StatDepthFilled, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_depth_filled <- function(
  mapping = NULL,
  data = NULL,
  geom = "contour_filled",
  position = "identity",
  contour = TRUE,
  contour_var = "depth",
  notion = "zonoid",
  notion_params = list(),
  n = 100L,
  show.legend = NA,
  inherit.aes = TRUE,
  ...
) {
    layer(data = data, mapping = mapping, stat = StatRowsDepthFilled, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(contour = contour, 
            contour_var = contour_var, notion = notion, 
            notion_params = notion_params, n = n, na.rm = FALSE, 
            ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsDepthFilled <- ggproto(
  "StatColsDepthFilled", StatDepthFilled,
  
  setup_data = setup_cols_data,
  
  compute_group = ord_formals(StatDepthFilled, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_depth_filled <- function(
  mapping = NULL,
  data = NULL,
  geom = "contour_filled",
  position = "identity",
  contour = TRUE,
  contour_var = "depth",
  notion = "zonoid",
  notion_params = list(),
  n = 100L,
  show.legend = NA,
  inherit.aes = TRUE,
  ...
) {
    layer(data = data, mapping = mapping, stat = StatColsDepthFilled, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(contour = contour, 
            contour_var = contour_var, notion = notion, 
            notion_params = notion_params, n = n, na.rm = FALSE, 
            ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsScale <- ggproto(
  "StatRowsScale", StatScale,
  
  setup_data = setup_rows_xy_data,
  
  compute_group = ord_formals(StatScale, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_scale <- function(
  mapping = NULL,
  data = NULL,
  geom = "point",
  position = "identity",
  show.legend = NA,
  inherit.aes = TRUE,
  ...,
  mult = 1
) {
    layer(data = data, mapping = mapping, stat = StatRowsScale, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(mult = mult, 
            na.rm = FALSE, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsScale <- ggproto(
  "StatColsScale", StatScale,
  
  setup_data = setup_cols_xy_data,
  
  compute_group = ord_formals(StatScale, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_scale <- function(
  mapping = NULL,
  data = NULL,
  geom = "point",
  position = "identity",
  show.legend = NA,
  inherit.aes = TRUE,
  ...,
  mult = 1
) {
    layer(data = data, mapping = mapping, stat = StatColsScale, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(mult = mult, 
            na.rm = FALSE, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsSpantree <- ggproto(
  "StatRowsSpantree", StatSpantree,
  
  setup_data = setup_rows_data,
  
  compute_group = ord_formals(StatSpantree, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_spantree <- function(
  mapping = NULL,
  data = NULL,
  geom = "segment",
  position = "identity",
  engine = "mlpack",
  method = "euclidean",
  show.legend = NA,
  inherit.aes = TRUE,
  ...
) {
    layer(data = data, mapping = mapping, stat = StatRowsSpantree, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, check.aes = FALSE, params = list(engine = engine, 
            method = method, na.rm = FALSE, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsSpantree <- ggproto(
  "StatColsSpantree", StatSpantree,
  
  setup_data = setup_cols_data,
  
  compute_group = ord_formals(StatSpantree, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_spantree <- function(
  mapping = NULL,
  data = NULL,
  geom = "segment",
  position = "identity",
  engine = "mlpack",
  method = "euclidean",
  show.legend = NA,
  inherit.aes = TRUE,
  ...
) {
    layer(data = data, mapping = mapping, stat = StatColsSpantree, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, check.aes = FALSE, params = list(engine = engine, 
            method = method, na.rm = FALSE, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsBagplot <- ggproto(
  "StatRowsBagplot", StatBagplot,
  
  setup_data = setup_rows_data,
  
  compute_group = ord_formals(StatBagplot, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_bagplot <- function(
  mapping = NULL,
  data = NULL,
  geom = "bagplot",
  position = "identity",
  fraction = 0.5,
  coef = 3,
  median = TRUE,
  fence = TRUE,
  outliers = TRUE,
  show.legend = NA,
  inherit.aes = TRUE,
  ...
) {
    layer(data = data, mapping = mapping, stat = StatRowsBagplot, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(fraction = fraction, 
            coef = coef, median = median, fence = fence, 
            outliers = outliers, na.rm = FALSE, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsBagplot <- ggproto(
  "StatColsBagplot", StatBagplot,
  
  setup_data = setup_cols_data,
  
  compute_group = ord_formals(StatBagplot, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_bagplot <- function(
  mapping = NULL,
  data = NULL,
  geom = "bagplot",
  position = "identity",
  fraction = 0.5,
  coef = 3,
  median = TRUE,
  fence = TRUE,
  outliers = TRUE,
  show.legend = NA,
  inherit.aes = TRUE,
  ...
) {
    layer(data = data, mapping = mapping, stat = StatColsBagplot, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(fraction = fraction, 
            coef = coef, median = median, fence = fence, 
            outliers = outliers, na.rm = FALSE, ...))    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsRule <- ggproto(
  "StatRowsRule", StatRule,
  
  extra_params = c(StatRule$extra_params, "ref_subset", "ref_elements"),
  
  setup_params = setup_referent_params,
  
  setup_data = setup_rows_xy_data,
  
  compute_group = ord_formals(StatRule, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_rule <- function(
  mapping = NULL,
  data = NULL,
  geom = "rule",
  position = "identity",
  fun.lower = "minpp",
  fun.upper = "maxpp",
  fun.offset = "minabspp",
  fun.args = list(),
  referent = NULL,
  show.legend = NA,
  inherit.aes = TRUE,
  ref_subset = NULL, ref_elements = "active",
  ...
) {
    LayerRef <- layer(data = data, mapping = mapping, stat = StatRowsRule, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(referent = referent,
            ref_subset = ref_subset, ref_elements = ref_elements, 
            fun.lower = fun.lower, fun.upper = fun.upper, 
            fun.offset = fun.offset, fun.args = fun.args, 
            na.rm = FALSE, ...))
    class(LayerRef) <- c("LayerRef", class(LayerRef))
    LayerRef    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsRule <- ggproto(
  "StatColsRule", StatRule,
  
  extra_params = c(StatRule$extra_params, "ref_subset", "ref_elements"),
  
  setup_params = setup_referent_params,
  
  setup_data = setup_cols_xy_data,
  
  compute_group = ord_formals(StatRule, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_rule <- function(
  mapping = NULL,
  data = NULL,
  geom = "rule",
  position = "identity",
  fun.lower = "minpp",
  fun.upper = "maxpp",
  fun.offset = "minabspp",
  fun.args = list(),
  referent = NULL,
  show.legend = NA,
  inherit.aes = TRUE,
  ref_subset = NULL, ref_elements = "active",
  ...
) {
    LayerRef <- layer(data = data, mapping = mapping, stat = StatColsRule, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(referent = referent,
            ref_subset = ref_subset, ref_elements = ref_elements, 
            fun.lower = fun.lower, fun.upper = fun.upper, 
            fun.offset = fun.offset, fun.args = fun.args, 
            na.rm = FALSE, ...))
    class(LayerRef) <- c("LayerRef", class(LayerRef))
    LayerRef    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatRowsProjection <- ggproto(
  "StatRowsProjection", StatProjection,
  
  extra_params = c(StatProjection$extra_params, "ref_subset", "ref_elements"),
  
  setup_params = setup_referent_params,
  
  setup_data = setup_rows_xy_data,
  
  compute_group = ord_formals(StatProjection, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_rows_projection <- function(
  mapping = NULL,
  data = NULL,
  geom = "segment",
  position = "identity",
  referent = NULL,
  ref_subset = NULL, ref_elements = "active",
  ...,
  show.legend = NA,
  inherit.aes = TRUE
) {
    LayerRef <- layer(data = data, mapping = mapping, stat = StatRowsProjection, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(referent = referent,
            ref_subset = ref_subset, ref_elements = ref_elements, 
            na.rm = FALSE, ...))
    class(LayerRef) <- c("LayerRef", class(LayerRef))
    LayerRef    
    
}

#' @rdname ordr-ggproto
#' @format NULL
#' @usage NULL
#' @export
StatColsProjection <- ggproto(
  "StatColsProjection", StatProjection,
  
  extra_params = c(StatProjection$extra_params, "ref_subset", "ref_elements"),
  
  setup_params = setup_referent_params,
  
  setup_data = setup_cols_xy_data,
  
  compute_group = ord_formals(StatProjection, "compute_group")
)

#' @rdname biplot-stats
#' @export
stat_cols_projection <- function(
  mapping = NULL,
  data = NULL,
  geom = "segment",
  position = "identity",
  referent = NULL,
  ref_subset = NULL, ref_elements = "active",
  ...,
  show.legend = NA,
  inherit.aes = TRUE
) {
    LayerRef <- layer(data = data, mapping = mapping, stat = StatColsProjection, 
        geom = geom, position = position, show.legend = show.legend, 
        inherit.aes = inherit.aes, params = list(referent = referent,
            ref_subset = ref_subset, ref_elements = ref_elements, 
            na.rm = FALSE, ...))
    class(LayerRef) <- c("LayerRef", class(LayerRef))
    LayerRef    
    
}
